﻿/*
 * TWI.c
 *
 * Created: 20.05.2021 12:41:36
 *  Author: Dmitriy
 */ 
#define F_CPU 8000000UL
#define F_SCL 400000UL
#include "TWI.h"
//========================================================================================================
//Инициализация twi
//========================================================================================================
void twi_Init(void)
{
	TWSR = 0; //Очищаются биты TWPS0 и TWPS1
	TWBR = ( ( (F_CPU)/(F_SCL)-16 ) /2 ) ;
}
//========================================================================================================
void TWI_Start()
{
		// Сброс флага прерывания TWINT, установка Старта, установка разрешения работы twi
	TWCR =(1<<TWINT)|(1<<TWEN)|(1<<TWSTA);
	// Ждем пока будет свободна линия, если занята
	while((TWCR & (1<<TWINT)) == 0);
	while((TWSR & (0xF8)) != START );	// 0x08 сигнал START передан
}
//========================================================================================================
		// Передаем адрес
void TWI_WRITE_ADDR (uint8_t ADDR)
{
	TWDR = ADDR;
	TWCR = (1<<TWINT)|(1<<TWEN);
	while((TWCR & (1<<TWINT)) == 0 );
	while((TWSR & (0xF8)) != MT_ADDR_ACK );		// 0x18 — Адрес для записи передан, ответ (ACK) получен
}
//========================================================================================================
		// Передаём данные
void TWI_WRITE_DATA (uint8_t DATA)
{
	TWDR = DATA;
	TWCR = (1<<TWINT)|(1<<TWEN);
	while((TWCR & (1<<TWINT)) == 0 );
	while((TWSR & (0xF8)) != MT_DATA_ACK );		// 0x28 — Байт отправлен, ACK получен
}
//========================================================================================================
		// Передаем стоп
void TWI_STOP()
{
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	while(TWCR & (1<<TWSTO));
}
//========================================================================================================
		//чтение
unsigned char I2C_ReadByte(void)
{
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWEA);
	while (!(TWCR & (1<<TWINT)));//ожидание установки бита TWIN
	return TWDR;//читаем регистр данных
}
//=========================================================================================================
		//
unsigned char I2C_ReadLastByte(void)
{
	TWCR = (1<<TWINT)|(1<<TWEN);
	while (!(TWCR & (1<<TWINT)));//ожидание установки бита TWIN
	return TWDR;//читаем регистр данных
}