﻿/*
 * TWI.h
 *
 * Created: 20.05.2021 12:41:18
 *  Author: Dmitriy
 */ 
//============================================================================================

#ifndef TWI_H_
#define TWI_H_
#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>
#include "main.h"
#define START 0x08			// сигнал START передан
#define REP_START 0x10		//	сигнал REPEATED START передан
#define MT_DATA_ACK 0x28	//	0x28 — Байт отправлен, ACK получен
#define MT_DATA_NACK 0x30	//	0x30 — Байт отправлен, ACK не получен

//============================================================================================
#define MT_ADDR_ACK 0x18	//	0x18 — Адрес для записи передан, ответ (ACK) получен
#define MT_ADDR_NACK 0x20	//	0x20 — Адрес для записи передан, устройство не откликнулось
//============================================================================================
void twi_Init(void);
void TWI_Start();
void TWI_WRITE_ADDR (uint8_t ADDR);
void TWI_WRITE_DATA (uint8_t DATA);
void TWI_STOP();
unsigned char I2C_ReadByte(void);
unsigned char I2C_ReadLastByte(void);

#endif /* TWI_H_ */