/*
 * mcp4725.c
 *
 * Created: 20.05.2021 20:55:04
 *  Author: Dmitriy
 */ 
#define F_CPU 8000000UL
#include "mcp4725.h"
//#include "TWI.h"
//=================================================================================================================================================
//   DAC
//=================================================================================================================================================
void mcp4725_init(uint8_t address, uint8_t reset) 
{
	//init i2c
	void twi_Init();
	_delay_us(10);
	if (reset)
	{
		TWI_Start();
		TWI_WRITE_ADDR(I2C_WRITE + MCP4725_BASEADDRESS + address);// I2C_WRITE ( /) + MCP4725_BASEADDRESS (_) + address
		TWI_WRITE_DATA(0b00000000);
		TWI_WRITE_DATA(0b00000000);
		TWI_STOP();
	}

	//set power down mode
	//i2c_start_wait(I2C_WRITE + MCP4725_BASEADDRESS + address);// I2C_WRITE ( /) + MCP4725_BASEADDRESS (_) + address
	//#if MCP4725_POWERDOWNMODE == MCP4725_POWERDOWN1K
	//i2c_write(0b01000010);
	//#elif MCP4725_POWERDOWNMODE == MCP4725_POWERDOWN100K
	//i2c_write(0b01000100);
	//#elif MCP4725_POWERDOWNMODE == MCP4725_POWERDOWN500K
	//i2c_write(0b01000110);
	//#endif
	
}
//======================================================================================================================================================
//_2___
//======================================================================================================================================================
void mcp4725_setrawoutputfast(uint8_t address, uint16_t rawoutput)
{
	//write raw output value to register
	TWI_Start();
	TWI_WRITE_ADDR (I2C_WRITE + MCP4725_BASEADDRESS + address);// I2C_WRITE ( /) + MCP4725_BASEADDRESS (_) + address
	TWI_WRITE_DATA ((uint8_t)(rawoutput>>8));	//  4   
	TWI_WRITE_DATA ((uint8_t)(rawoutput));		// 8   
	TWI_STOP();
	
}
//=======================================================================================================================================================
//        DAC
//=======================================================================================================================================================
void mcp4725_setvoltagefast(uint8_t address, double voltage, double dacref) 
{
	uint16_t rawoutput = 0;

	//get the raw output
	rawoutput = voltage*4096/dacref;
	if (rawoutput > 4095)
	rawoutput = 4095;

	//write to chip
	mcp4725_setrawoutputfast(address, rawoutput);
}
//=========================================================================================================================================================
